Index: src/backend/commands/copy.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/copy.c,v
retrieving revision 1.245
diff -c -r1.245 copy.c
*** src/backend/commands/copy.c	2 Jun 2005 01:21:22 -0000	1.245
--- src/backend/commands/copy.c	27 Jun 2005 18:45:39 -0000
***************
*** 914,932 ****
  				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
  				 errmsg("must be superuser to COPY to or from a file"),
  				 errhint("Anyone can COPY to stdout or from stdin. "
! 					   "psql's \\copy command also works for anyone.")));
  
! 	/* Don't allow COPY w/ OIDs to or from a table without them */
  	if (oids && !rel->rd_rel->relhasoids)
  		ereport(ERROR,
  				(errcode(ERRCODE_UNDEFINED_COLUMN),
  				 errmsg("table \"%s\" does not have OIDs",
  						RelationGetRelationName(rel))));
  
! 	/* Generate or convert list of attributes to process */
  	attnumlist = CopyGetAttnums(rel, attnamelist);
  
! 	/* Check that FORCE QUOTE references valid COPY columns */
  	if (force_quote)
  	{
  		TupleDesc	tupDesc = RelationGetDescr(rel);
--- 1057,1081 ----
  				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
  				 errmsg("must be superuser to COPY to or from a file"),
  				 errhint("Anyone can COPY to stdout or from stdin. "
! 						 "psql's \\copy command also works for anyone.")));
  
! 	/*
! 	 * Don't allow COPY w/ OIDs to or from a table without them 
! 	 */
  	if (oids && !rel->rd_rel->relhasoids)
  		ereport(ERROR,
  				(errcode(ERRCODE_UNDEFINED_COLUMN),
  				 errmsg("table \"%s\" does not have OIDs",
  						RelationGetRelationName(rel))));
  
! 	/*
! 	 * Generate or convert list of attributes to process
! 	 */
  	attnumlist = CopyGetAttnums(rel, attnamelist);
  
! 	/*
! 	 * Check that FORCE QUOTE references valid COPY columns
! 	 */
  	if (force_quote)
  	{
  		TupleDesc	tupDesc = RelationGetDescr(rel);
***************
*** 942,953 ****
  			if (!list_member_int(attnumlist, attnum))
  				ereport(ERROR,
  						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
! 				errmsg("FORCE QUOTE column \"%s\" not referenced by COPY",
! 					   NameStr(attr[attnum - 1]->attname))));
  		}
  	}
  
! 	/* Check that FORCE NOT NULL references valid COPY columns */
  	if (force_notnull)
  	{
  		ListCell   *cur;
--- 1091,1105 ----
  			if (!list_member_int(attnumlist, attnum))
  				ereport(ERROR,
  						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
! 						 errmsg
! 						 ("FORCE QUOTE column \"%s\" not referenced by COPY",
! 						  NameStr(attr[attnum - 1]->attname))));
  		}
  	}
  
! 	/*
! 	 * Check that FORCE NOT NULL references valid COPY columns
! 	 */
  	if (force_notnull)
  	{
  		ListCell   *cur;
***************
*** 963,981 ****
  			if (!list_member_int(attnumlist, attnum))
  				ereport(ERROR,
  						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
! 						 errmsg("FORCE NOT NULL column \"%s\" not referenced by COPY",
! 								NameStr(attr[attnum - 1]->attname))));
  		}
  	}
  
! 	/* Set up variables to avoid per-attribute overhead. */
! 	initStringInfo(&attribute_buf);
  	initStringInfo(&line_buf);
  	line_buf_converted = false;
  
  	client_encoding = pg_get_client_encoding();
  	server_encoding = GetDatabaseEncoding();
  
  	copy_dest = COPY_FILE;		/* default */
  	copy_file = NULL;
  	copy_msgbuf = NULL;
--- 1115,1154 ----
  			if (!list_member_int(attnumlist, attnum))
  				ereport(ERROR,
  						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
! 						 errmsg
! 						 ("FORCE NOT NULL column \"%s\" not referenced by COPY",
! 						  NameStr(attr[attnum - 1]->attname))));
  		}
  	}
  
! 	/*
! 	 * Set up variables to avoid per-attribute overhead.
! 	 */
! 	initStringInfo(&attr_buf);
  	initStringInfo(&line_buf);
  	line_buf_converted = false;
  
  	client_encoding = pg_get_client_encoding();
  	server_encoding = GetDatabaseEncoding();
  
+ 	/*
+ 	 * check if the client encoding is one of the 5 encodings
+ 	 * that are not supported as a server encodings.
+ 	 */
+ 	switch (client_encoding)
+ 	{
+ 		case PG_SJIS:
+ 		case PG_BIG5:
+ 		case PG_GBK:
+ 		case PG_UHC:
+ 		case PG_GB18030:
+ 			client_encoding_only = true;
+ 			break;
+ 		default:
+ 			client_encoding_only = false;
+ 	}
+ 
+ 
  	copy_dest = COPY_FILE;		/* default */
  	copy_file = NULL;
  	copy_msgbuf = NULL;
***************
*** 998,1005 ****
  			else
  				ereport(ERROR,
  						(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 					   errmsg("cannot copy to non-table relation \"%s\"",
! 							  RelationGetRelationName(rel))));
  		}
  		if (pipe)
  		{
--- 1171,1178 ----
  			else
  				ereport(ERROR,
  						(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 						 errmsg("cannot copy to non-table relation \"%s\"",
! 								RelationGetRelationName(rel))));
  		}
  		if (pipe)
  		{
***************
*** 1017,1024 ****
  			if (copy_file == NULL)
  				ereport(ERROR,
  						(errcode_for_file_access(),
! 					 errmsg("could not open file \"%s\" for reading: %m",
! 							filename)));
  
  			fstat(fileno(copy_file), &st);
  			if (S_ISDIR(st.st_mode))
--- 1190,1197 ----
  			if (copy_file == NULL)
  				ereport(ERROR,
  						(errcode_for_file_access(),
! 						 errmsg("could not open file \"%s\" for reading: %m",
! 								filename)));
  
  			fstat(fileno(copy_file), &st);
  			if (S_ISDIR(st.st_mode))
***************
*** 1029,1036 ****
  						 errmsg("\"%s\" is a directory", filename)));
  			}
  		}
! 		CopyFrom(rel, attnumlist, binary, oids, delim, null_print, csv_mode,
! 				 quote, escape, force_notnull_atts, header_line);
  	}
  	else
  	{							/* copy from database to file */
--- 1202,1218 ----
  						 errmsg("\"%s\" is a directory", filename)));
  			}
  		}
! 
! 		if (csv_mode || binary) /* old path */
! 			CopyFrom(rel, attnumlist, binary, oids, delim, null_print,
! 					 csv_mode, quote, escape, force_notnull_atts, header_line);
! 		/*
! 		 * new path for improved performance (only for delimited format for now)
! 		 */
! 		else
! 			CopyFromDelimited(rel, attnumlist, binary, oids, delim, null_print,
! 							  csv_mode, quote, escape, force_notnull_atts);
! 
  	}
  	else
  	{							/* copy from database to file */
***************
*** 1049,1056 ****
  			else
  				ereport(ERROR,
  						(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 					 errmsg("cannot copy from non-table relation \"%s\"",
! 							RelationGetRelationName(rel))));
  		}
  		if (pipe)
  		{
--- 1231,1238 ----
  			else
  				ereport(ERROR,
  						(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 						 errmsg("cannot copy from non-table relation \"%s\"",
! 								RelationGetRelationName(rel))));
  		}
  		if (pipe)
  		{
***************
*** 1071,1077 ****
  			if (!is_absolute_path(filename))
  				ereport(ERROR,
  						(errcode(ERRCODE_INVALID_NAME),
! 				  errmsg("relative path not allowed for COPY to file")));
  
  			oumask = umask((mode_t) 022);
  			copy_file = AllocateFile(filename, PG_BINARY_W);
--- 1253,1260 ----
  			if (!is_absolute_path(filename))
  				ereport(ERROR,
  						(errcode(ERRCODE_INVALID_NAME),
! 						 errmsg
! 						 ("relative path not allowed for COPY to file")));
  
  			oumask = umask((mode_t) 022);
  			copy_file = AllocateFile(filename, PG_BINARY_W);
***************
*** 1080,1087 ****
  			if (copy_file == NULL)
  				ereport(ERROR,
  						(errcode_for_file_access(),
! 					 errmsg("could not open file \"%s\" for writing: %m",
! 							filename)));
  
  			fstat(fileno(copy_file), &st);
  			if (S_ISDIR(st.st_mode))
--- 1263,1270 ----
  			if (copy_file == NULL)
  				ereport(ERROR,
  						(errcode_for_file_access(),
! 						 errmsg("could not open file \"%s\" for writing: %m",
! 								filename)));
  
  			fstat(fileno(copy_file), &st);
  			if (S_ISDIR(st.st_mode))
***************
*** 1099,1114 ****
  
  	if (!pipe)
  	{
! 		/* we assume only the write case could fail here */
  		if (FreeFile(copy_file))
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not write to file \"%s\": %m",
! 							filename)));
  	}
! 	pfree(attribute_buf.data);
  	pfree(line_buf.data);
  
  	/*
  	 * Close the relation.	If reading, we can release the AccessShareLock
  	 * we got; if writing, we should hold the lock until end of
--- 1282,1299 ----
  
  	if (!pipe)
  	{
! 		/*
! 		 * we assume only the write case could fail here
! 		 */
  		if (FreeFile(copy_file))
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not write to file \"%s\": %m", filename)));
  	}
! 	pfree(attr_buf.data);
  	pfree(line_buf.data);
  
+ 
  	/*
  	 * Close the relation.	If reading, we can release the AccessShareLock
  	 * we got; if writing, we should hold the lock until end of
***************
*** 1178,1184 ****
  	num_phys_attrs = tupDesc->natts;
  	attr_count = list_length(attnumlist);
  
! 	/* Get info about the columns we need to process. */
  	out_functions = (FmgrInfo *) palloc(num_phys_attrs * sizeof(FmgrInfo));
  	force_quote = (bool *) palloc(num_phys_attrs * sizeof(bool));
  	foreach(cur, attnumlist)
--- 1363,1371 ----
  	num_phys_attrs = tupDesc->natts;
  	attr_count = list_length(attnumlist);
  
! 	/*
! 	 * Get info about the columns we need to process.
! 	 */
  	out_functions = (FmgrInfo *) palloc(num_phys_attrs * sizeof(FmgrInfo));
  	force_quote = (bool *) palloc(num_phys_attrs * sizeof(bool));
  	foreach(cur, attnumlist)
***************
*** 1189,1200 ****
  
  		if (binary)
  			getTypeBinaryOutputInfo(attr[attnum - 1]->atttypid,
! 									&out_func_oid,
! 									&isvarlena);
  		else
  			getTypeOutputInfo(attr[attnum - 1]->atttypid,
! 							  &out_func_oid,
! 							  &isvarlena);
  		fmgr_info(out_func_oid, &out_functions[attnum - 1]);
  
  		if (list_member_int(force_quote_atts, attnum))
--- 1376,1385 ----
  
  		if (binary)
  			getTypeBinaryOutputInfo(attr[attnum - 1]->atttypid,
! 									&out_func_oid, &isvarlena);
  		else
  			getTypeOutputInfo(attr[attnum - 1]->atttypid,
! 							  &out_func_oid, &isvarlena);
  		fmgr_info(out_func_oid, &out_functions[attnum - 1]);
  
  		if (list_member_int(force_quote_atts, attnum))
***************
*** 1217,1233 ****
  
  	if (binary)
  	{
! 		/* Generate header for a binary copy */
  		int32		tmp;
  
! 		/* Signature */
  		CopySendData((char *) BinarySignature, 11);
! 		/* Flags field */
  		tmp = 0;
  		if (oids)
  			tmp |= (1 << 16);
  		CopySendInt32(tmp);
! 		/* No header extension */
  		tmp = 0;
  		CopySendInt32(tmp);
  	}
--- 1402,1426 ----
  
  	if (binary)
  	{
! 		/*
! 		 * Generate header for a binary copy
! 		 */
  		int32		tmp;
  
! 		/*
! 		 * Signature
! 		 */
  		CopySendData((char *) BinarySignature, 11);
! 		/*
! 		 * Flags field
! 		 */
  		tmp = 0;
  		if (oids)
  			tmp |= (1 << 16);
  		CopySendInt32(tmp);
! 		/*
! 		 * No header extension
! 		 */
  		tmp = 0;
  		CopySendInt32(tmp);
  	}
***************
*** 1242,1253 ****
  				pg_server_to_client((unsigned char *) null_print,
  									strlen(null_print));
  
! 		/* if a header has been requested send the line */
  		if (header_line)
  		{
! 			bool hdr_delim = false;
! 			char *colname;
! 			
  			foreach(cur, attnumlist)
  			{
  				int			attnum = lfirst_int(cur);
--- 1435,1448 ----
  				pg_server_to_client((unsigned char *) null_print,
  									strlen(null_print));
  
! 		/*
! 		 * if a header has been requested send the line
! 		 */
  		if (header_line)
  		{
! 			bool		hdr_delim = false;
! 			char	   *colname;
! 
  			foreach(cur, attnumlist)
  			{
  				int			attnum = lfirst_int(cur);
***************
*** 1280,1304 ****
  
  		if (binary)
  		{
! 			/* Binary per-tuple header */
  			CopySendInt16(attr_count);
! 			/* Send OID if wanted --- note attr_count doesn't include it */
  			if (oids)
  			{
  				Oid			oid = HeapTupleGetOid(tuple);
  
! 				/* Hack --- assume Oid is same size as int32 */
  				CopySendInt32(sizeof(int32));
  				CopySendInt32(oid);
  			}
  		}
  		else
  		{
! 			/* Text format has no per-tuple header, but send OID if wanted */
  			if (oids)
  			{
  				string = DatumGetCString(DirectFunctionCall1(oidout,
! 							  ObjectIdGetDatum(HeapTupleGetOid(tuple))));
  				CopySendString(string);
  				need_delim = true;
  			}
--- 1475,1509 ----
  
  		if (binary)
  		{
! 			/*
! 			 * Binary per-tuple header
! 			 */
  			CopySendInt16(attr_count);
! 			/*
! 			 * Send OID if wanted --- note attr_count doesn't include it 
! 			 */
  			if (oids)
  			{
  				Oid			oid = HeapTupleGetOid(tuple);
  
! 				/*
! 				 * Hack --- assume Oid is same size as int32
! 				 */
  				CopySendInt32(sizeof(int32));
  				CopySendInt32(oid);
  			}
  		}
  		else
  		{
! 			/*
! 			 * Text format has no per-tuple header, but send OID if wanted
! 			 */
  			if (oids)
  			{
  				string = DatumGetCString(DirectFunctionCall1(oidout,
! 															 ObjectIdGetDatum
! 															 (HeapTupleGetOid
! 															  (tuple))));
  				CopySendString(string);
  				need_delim = true;
  			}
***************
*** 1330,1342 ****
  			{
  				if (!binary)
  				{
! 					string = DatumGetCString(FunctionCall1(&out_functions[attnum - 1],
! 														   value));
  					if (csv_mode)
  					{
  						CopyAttributeOutCSV(string, delim, quote, escape,
! 									  (strcmp(string, null_print) == 0 ||
! 									   force_quote[attnum - 1]));
  					}
  					else
  						CopyAttributeOut(string, delim);
--- 1535,1548 ----
  			{
  				if (!binary)
  				{
! 					string =
! 						DatumGetCString(FunctionCall1
! 										(&out_functions[attnum - 1], value));
  					if (csv_mode)
  					{
  						CopyAttributeOutCSV(string, delim, quote, escape,
! 											(strcmp(string, null_print) == 0 ||
! 											 force_quote[attnum - 1]));
  					}
  					else
  						CopyAttributeOut(string, delim);
***************
*** 1346,1354 ****
  				{
  					bytea	   *outputbytes;
  
! 					outputbytes = DatumGetByteaP(FunctionCall1(&out_functions[attnum - 1],
! 															   value));
! 					/* We assume the result will not have been toasted */
  					CopySendInt32(VARSIZE(outputbytes) - VARHDRSZ);
  					CopySendData(VARDATA(outputbytes),
  								 VARSIZE(outputbytes) - VARHDRSZ);
--- 1552,1563 ----
  				{
  					bytea	   *outputbytes;
  
! 					outputbytes =
! 						DatumGetByteaP(FunctionCall1
! 									   (&out_functions[attnum - 1], value));
! 					/*
! 					 * We assume the result will not have been toasted
! 					 */
  					CopySendInt32(VARSIZE(outputbytes) - VARHDRSZ);
  					CopySendData(VARDATA(outputbytes),
  								 VARSIZE(outputbytes) - VARHDRSZ);
***************
*** 1365,1371 ****
  
  	if (binary)
  	{
! 		/* Generate trailer for a binary copy */
  		CopySendInt16(-1);
  	}
  
--- 1574,1582 ----
  
  	if (binary)
  	{
! 		/*
! 		 * Generate trailer for a binary copy
! 		 */
  		CopySendInt16(-1);
  	}
  
***************
*** 1384,1390 ****
  {
  	if (copy_binary)
  	{
! 		/* can't usefully display the data */
  		if (copy_attname)
  			errcontext("COPY %s, line %d, column %s",
  					   copy_relname, copy_lineno, copy_attname);
--- 1595,1603 ----
  {
  	if (copy_binary)
  	{
! 		/*
! 		 * can't usefully display the data 
! 		 */
  		if (copy_attname)
  			errcontext("COPY %s, line %d, column %s",
  					   copy_relname, copy_lineno, copy_attname);
***************
*** 1395,1423 ****
  	{
  		if (copy_attname)
  		{
! 			/* error is relevant to a particular column */
! 			limit_printout_length(&attribute_buf);
  			errcontext("COPY %s, line %d, column %s: \"%s\"",
! 					   copy_relname, copy_lineno, copy_attname,
! 					   attribute_buf.data);
  		}
  		else
  		{
! 			/* error is relevant to a particular line */
! 			if (line_buf_converted ||
! 				client_encoding == server_encoding)
  			{
  				limit_printout_length(&line_buf);
  				errcontext("COPY %s, line %d: \"%s\"",
! 						   copy_relname, copy_lineno,
! 						   line_buf.data);
  			}
  			else
  			{
  				/*
  				 * Here, the line buffer is still in a foreign encoding,
  				 * and indeed it's quite likely that the error is precisely
! 				 * a failure to do encoding conversion (ie, bad data).  We
  				 * dare not try to convert it, and at present there's no way
  				 * to regurgitate it without conversion.  So we have to punt
  				 * and just report the line number.
--- 1608,1641 ----
  	{
  		if (copy_attname)
  		{
! 			/*
! 			 * error is relevant to a particular column
! 			 */
! 			limit_printout_length(&attr_buf);
  			errcontext("COPY %s, line %d, column %s: \"%s\"",
! 					   copy_relname, copy_lineno, copy_attname, attr_buf.data);
  		}
  		else
  		{
! 			/*
! 			 * error is relevant to a particular line
! 			 */
! 			if (line_buf_converted || client_encoding == server_encoding)
  			{
+ 				/*
+ 				 * Strip off the newline
+ 				 */
+ 				*(line_buf.data + line_buf.len - 1) = '\0';
  				limit_printout_length(&line_buf);
  				errcontext("COPY %s, line %d: \"%s\"",
! 						   copy_relname, copy_lineno, line_buf.data);
  			}
  			else
  			{
  				/*
  				 * Here, the line buffer is still in a foreign encoding,
  				 * and indeed it's quite likely that the error is precisely
! 				 * a failure to do encoding conversion (ie, bad data).	We
  				 * dare not try to convert it, and at present there's no way
  				 * to regurgitate it without conversion.  So we have to punt
  				 * and just report the line number.
***************
*** 1445,1465 ****
  
  	int			len;
  
! 	/* Fast path if definitely okay */
  	if (buf->len <= MAX_COPY_DATA_DISPLAY)
  		return;
  
! 	/* Apply encoding-dependent truncation */
  	len = pg_mbcliplen(buf->data, buf->len, MAX_COPY_DATA_DISPLAY);
  	if (buf->len <= len)
  		return;					/* no need to truncate */
  	buf->len = len;
  	buf->data[len] = '\0';
  
! 	/* Add "..." to show we truncated the input */
  	appendStringInfoString(buf, "...");
  }
  
  /*
   * Copy FROM file to relation.
   */
--- 1663,1690 ----
  
  	int			len;
  
! 	/*
! 	 * Fast path if definitely okay
! 	 */
  	if (buf->len <= MAX_COPY_DATA_DISPLAY)
  		return;
  
! 	/*
! 	 * Apply encoding-dependent truncation
! 	 */
  	len = pg_mbcliplen(buf->data, buf->len, MAX_COPY_DATA_DISPLAY);
  	if (buf->len <= len)
  		return;					/* no need to truncate */
  	buf->len = len;
  	buf->data[len] = '\0';
  
! 	/*
! 	 * Add "..." to show we truncated the input
! 	 */
  	appendStringInfoString(buf, "...");
  }
  
+ 
  /*
   * Copy FROM file to relation.
   */
***************
*** 1510,1521 ****
  	 * code here that basically duplicated execUtils.c ...)
  	 */
  	resultRelInfo = makeNode(ResultRelInfo);
  	resultRelInfo->ri_RangeTableIndex = 1;		/* dummy */
  	resultRelInfo->ri_RelationDesc = rel;
  	resultRelInfo->ri_TrigDesc = CopyTriggerDesc(rel->trigdesc);
  	if (resultRelInfo->ri_TrigDesc)
  		resultRelInfo->ri_TrigFunctions = (FmgrInfo *)
! 			palloc0(resultRelInfo->ri_TrigDesc->numtriggers * sizeof(FmgrInfo));
  	resultRelInfo->ri_TrigInstrument = NULL;
  
  	ExecOpenIndices(resultRelInfo);
--- 1735,1748 ----
  	 * code here that basically duplicated execUtils.c ...)
  	 */
  	resultRelInfo = makeNode(ResultRelInfo);
+ 
  	resultRelInfo->ri_RangeTableIndex = 1;		/* dummy */
  	resultRelInfo->ri_RelationDesc = rel;
  	resultRelInfo->ri_TrigDesc = CopyTriggerDesc(rel->trigdesc);
  	if (resultRelInfo->ri_TrigDesc)
  		resultRelInfo->ri_TrigFunctions = (FmgrInfo *)
! 			palloc0(resultRelInfo->ri_TrigDesc->numtriggers *
! 					sizeof(FmgrInfo));
  	resultRelInfo->ri_TrigInstrument = NULL;
  
  	ExecOpenIndices(resultRelInfo);
***************
*** 1524,1530 ****
  	estate->es_num_result_relations = 1;
  	estate->es_result_relation_info = resultRelInfo;
  
! 	/* Set up a tuple slot too */
  	slot = MakeSingleTupleTableSlot(tupDesc);
  
  	econtext = GetPerTupleExprContext(estate);
--- 1751,1759 ----
  	estate->es_num_result_relations = 1;
  	estate->es_result_relation_info = resultRelInfo;
  
! 	/*
! 	 * Set up a tuple slot too
! 	 */
  	slot = MakeSingleTupleTableSlot(tupDesc);
  
  	econtext = GetPerTupleExprContext(estate);
***************
*** 1539,1557 ****
  	typioparams = (Oid *) palloc(num_phys_attrs * sizeof(Oid));
  	defmap = (int *) palloc(num_phys_attrs * sizeof(int));
  	defexprs = (ExprState **) palloc(num_phys_attrs * sizeof(ExprState *));
! 	constraintexprs = (ExprState **) palloc0(num_phys_attrs * sizeof(ExprState *));
  	force_notnull = (bool *) palloc(num_phys_attrs * sizeof(bool));
  
  	for (attnum = 1; attnum <= num_phys_attrs; attnum++)
  	{
! 		/* We don't need info for dropped attributes */
  		if (attr[attnum - 1]->attisdropped)
  			continue;
  
! 		/* Fetch the input function and typioparam info */
  		if (binary)
  			getTypeBinaryInputInfo(attr[attnum - 1]->atttypid,
! 								 &in_func_oid, &typioparams[attnum - 1]);
  		else
  			getTypeInputInfo(attr[attnum - 1]->atttypid,
  							 &in_func_oid, &typioparams[attnum - 1]);
--- 1768,1791 ----
  	typioparams = (Oid *) palloc(num_phys_attrs * sizeof(Oid));
  	defmap = (int *) palloc(num_phys_attrs * sizeof(int));
  	defexprs = (ExprState **) palloc(num_phys_attrs * sizeof(ExprState *));
! 	constraintexprs =
! 		(ExprState **) palloc0(num_phys_attrs * sizeof(ExprState *));
  	force_notnull = (bool *) palloc(num_phys_attrs * sizeof(bool));
  
  	for (attnum = 1; attnum <= num_phys_attrs; attnum++)
  	{
! 		/*
! 		 * We don't need info for dropped attributes 
! 		 */
  		if (attr[attnum - 1]->attisdropped)
  			continue;
  
! 		/*
! 		 * Fetch the input function and typioparam info
! 		 */
  		if (binary)
  			getTypeBinaryInputInfo(attr[attnum - 1]->atttypid,
! 								   &in_func_oid, &typioparams[attnum - 1]);
  		else
  			getTypeInputInfo(attr[attnum - 1]->atttypid,
  							 &in_func_oid, &typioparams[attnum - 1]);
***************
*** 1562,1572 ****
  		else
  			force_notnull[attnum - 1] = false;
  
! 		/* Get default info if needed */
  		if (!list_member_int(attnumlist, attnum))
  		{
! 			/* attribute is NOT to be copied from input */
! 			/* use default value if one exists */
  			Node	   *defexpr = build_column_default(rel, attnum);
  
  			if (defexpr != NULL)
--- 1796,1812 ----
  		else
  			force_notnull[attnum - 1] = false;
  
! 		/*
! 		 * Get default info if needed
! 		 */
  		if (!list_member_int(attnumlist, attnum))
  		{
! 			/*
! 			 * attribute is NOT to be copied from input
! 			 */
! 			/*
! 			 * use default value if one exists
! 			 */
  			Node	   *defexpr = build_column_default(rel, attnum);
  
  			if (defexpr != NULL)
***************
*** 1578,1584 ****
  			}
  		}
  
! 		/* If it's a domain type, set up to check domain constraints */
  		if (get_typtype(attr[attnum - 1]->atttypid) == 'd')
  		{
  			Param	   *prm;
--- 1818,1826 ----
  			}
  		}
  
! 		/*
! 		 * If it's a domain type, set up to check domain constraints 
! 		 */
  		if (get_typtype(attr[attnum - 1]->atttypid) == 'd')
  		{
  			Param	   *prm;
***************
*** 1593,1598 ****
--- 1835,1841 ----
  			 * actual datum during the data input loop.
  			 */
  			prm = makeNode(Param);
+ 
  			prm->paramkind = PARAM_EXEC;
  			prm->paramid = 0;
  			prm->paramtype = getBaseType(attr[attnum - 1]->atttypid);
***************
*** 1608,1614 ****
  		}
  	}
  
! 	/* Prepare to catch AFTER triggers. */
  	AfterTriggerBeginQuery();
  
  	/*
--- 1851,1859 ----
  		}
  	}
  
! 	/*
! 	 * Prepare to catch AFTER triggers.
! 	 */
  	AfterTriggerBeginQuery();
  
  	/*
***************
*** 1624,1640 ****
  		file_has_oids = oids;	/* must rely on user to tell us this... */
  	else
  	{
! 		/* Read and verify binary header */
  		char		readSig[11];
  		int32		tmp;
  
! 		/* Signature */
  		CopyGetData(readSig, 11);
  		if (CopyGetEof() || memcmp(readSig, BinarySignature, 11) != 0)
  			ereport(ERROR,
  					(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  					 errmsg("COPY file signature not recognized")));
! 		/* Flags field */
  		tmp = CopyGetInt32();
  		if (CopyGetEof())
  			ereport(ERROR,
--- 1869,1891 ----
  		file_has_oids = oids;	/* must rely on user to tell us this... */
  	else
  	{
! 		/*
! 		 * Read and verify binary header
! 		 */
  		char		readSig[11];
  		int32		tmp;
  
! 		/*
! 		 * Signature
! 		 */
  		CopyGetData(readSig, 11);
  		if (CopyGetEof() || memcmp(readSig, BinarySignature, 11) != 0)
  			ereport(ERROR,
  					(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  					 errmsg("COPY file signature not recognized")));
! 		/*
! 		 * Flags field
! 		 */
  		tmp = CopyGetInt32();
  		if (CopyGetEof())
  			ereport(ERROR,
***************
*** 1645,1684 ****
  		if ((tmp >> 16) != 0)
  			ereport(ERROR,
  					(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 			 errmsg("unrecognized critical flags in COPY file header")));
! 		/* Header extension length */
  		tmp = CopyGetInt32();
  		if (CopyGetEof() || tmp < 0)
  			ereport(ERROR,
  					(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 				   errmsg("invalid COPY file header (missing length)")));
! 		/* Skip extension header, if present */
  		while (tmp-- > 0)
  		{
  			CopyGetData(readSig, 1);
  			if (CopyGetEof())
  				ereport(ERROR,
  						(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 					 errmsg("invalid COPY file header (wrong length)")));
  		}
  	}
  
  	if (file_has_oids && binary)
  	{
! 		getTypeBinaryInputInfo(OIDOID,
! 							   &in_func_oid, &oid_typioparam);
  		fmgr_info(in_func_oid, &oid_in_function);
  	}
  
  	values = (Datum *) palloc(num_phys_attrs * sizeof(Datum));
  	nulls = (char *) palloc(num_phys_attrs * sizeof(char));
  
! 	/* Make room for a PARAM_EXEC value for domain constraint checks */
  	if (hasConstraints)
  		econtext->ecxt_param_exec_vals = (ParamExecData *)
  			palloc0(sizeof(ParamExecData));
  
! 	/* Initialize static variables */
  	fe_eof = false;
  	eol_type = EOL_UNKNOWN;
  	copy_binary = binary;
--- 1896,1943 ----
  		if ((tmp >> 16) != 0)
  			ereport(ERROR,
  					(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 					 errmsg
! 					 ("unrecognized critical flags in COPY file header")));
! 		/*
! 		 * Header extension length
! 		 */
  		tmp = CopyGetInt32();
  		if (CopyGetEof() || tmp < 0)
  			ereport(ERROR,
  					(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 					 errmsg("invalid COPY file header (missing length)")));
! 		/*
! 		 * Skip extension header, if present
! 		 */
  		while (tmp-- > 0)
  		{
  			CopyGetData(readSig, 1);
  			if (CopyGetEof())
  				ereport(ERROR,
  						(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 						 errmsg("invalid COPY file header (wrong length)")));
  		}
  	}
  
  	if (file_has_oids && binary)
  	{
! 		getTypeBinaryInputInfo(OIDOID, &in_func_oid, &oid_typioparam);
  		fmgr_info(in_func_oid, &oid_in_function);
  	}
  
  	values = (Datum *) palloc(num_phys_attrs * sizeof(Datum));
  	nulls = (char *) palloc(num_phys_attrs * sizeof(char));
  
! 	/*
! 	 * Make room for a PARAM_EXEC value for domain constraint checks
! 	 */
  	if (hasConstraints)
  		econtext->ecxt_param_exec_vals = (ParamExecData *)
  			palloc0(sizeof(ParamExecData));
  
! 	/*
! 	 * Initialize static variables
! 	 */
  	fe_eof = false;
  	eol_type = EOL_UNKNOWN;
  	copy_binary = binary;
***************
*** 1686,1702 ****
  	copy_lineno = 0;
  	copy_attname = NULL;
  
! 	/* Set up callback to identify error line number */
  	errcontext.callback = copy_in_error_callback;
  	errcontext.arg = NULL;
  	errcontext.previous = error_context_stack;
  	error_context_stack = &errcontext;
  
! 	/* on input just throw the header line away */
  	if (header_line)
  	{
  		copy_lineno++;
! 		done = CopyReadLine(quote, escape) ;
  	}
  
  	while (!done)
--- 1945,1965 ----
  	copy_lineno = 0;
  	copy_attname = NULL;
  
! 	/*
! 	 * Set up callback to identify error line number
! 	 */
  	errcontext.callback = copy_in_error_callback;
  	errcontext.arg = NULL;
  	errcontext.previous = error_context_stack;
  	error_context_stack = &errcontext;
  
! 	/*
! 	 * on input just throw the header line away
! 	 */
  	if (header_line)
  	{
  		copy_lineno++;
! 		done = CopyReadLine(quote, escape);
  	}
  
  	while (!done)
***************
*** 1708,1720 ****
  
  		copy_lineno++;
  
! 		/* Reset the per-tuple exprcontext */
  		ResetPerTupleExprContext(estate);
  
! 		/* Switch into its memory context */
  		MemoryContextSwitchTo(GetPerTupleMemoryContext(estate));
  
! 		/* Initialize all values for row to NULL */
  		MemSet(values, 0, num_phys_attrs * sizeof(Datum));
  		MemSet(nulls, 'n', num_phys_attrs * sizeof(char));
  
--- 1971,1989 ----
  
  		copy_lineno++;
  
! 		/*
! 		 * Reset the per-tuple exprcontext
! 		 */
  		ResetPerTupleExprContext(estate);
  
! 		/*
! 		 * Switch into its memory context
! 		 */
  		MemoryContextSwitchTo(GetPerTupleMemoryContext(estate));
  
! 		/*
! 		 * Initialize all values for row to NULL
! 		 */
  		MemSet(values, 0, num_phys_attrs * sizeof(Datum));
  		MemSet(nulls, 'n', num_phys_attrs * sizeof(char));
  
***************
*** 1724,1731 ****
  			char	   *string;
  			ListCell   *cur;
  
! 			/* Actually read the line into memory here */
! 			done = csv_mode ? 
  				CopyReadLine(quote, escape) : CopyReadLine(NULL, NULL);
  
  			/*
--- 1993,2002 ----
  			char	   *string;
  			ListCell   *cur;
  
! 			/*
! 			 * Actually read the line into memory here
! 			 */
! 			done = csv_mode ?
  				CopyReadLine(quote, escape) : CopyReadLine(NULL, NULL);
  
  			/*
***************
*** 1739,1745 ****
  
  			if (file_has_oids)
  			{
! 				/* can't be in CSV mode here */
  				string = CopyReadAttribute(delim, null_print,
  										   &result, &isnull);
  
--- 2010,2018 ----
  
  			if (file_has_oids)
  			{
! 				/*
! 				 * can't be in CSV mode here 
! 				 */
  				string = CopyReadAttribute(delim, null_print,
  										   &result, &isnull);
  
***************
*** 1751,1757 ****
  				{
  					copy_attname = "oid";
  					loaded_oid = DatumGetObjectId(DirectFunctionCall1(oidin,
! 											   CStringGetDatum(string)));
  					if (loaded_oid == InvalidOid)
  						ereport(ERROR,
  								(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
--- 2024,2031 ----
  				{
  					copy_attname = "oid";
  					loaded_oid = DatumGetObjectId(DirectFunctionCall1(oidin,
! 																	  CStringGetDatum
! 																	  (string)));
  					if (loaded_oid == InvalidOid)
  						ereport(ERROR,
  								(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
***************
*** 1760,1766 ****
  				}
  			}
  
! 			/* Loop to read the user attributes on the line. */
  			foreach(cur, attnumlist)
  			{
  				int			attnum = lfirst_int(cur);
--- 2034,2042 ----
  				}
  			}
  
! 			/*
! 			 * Loop to read the user attributes on the line.
! 			 */
  			foreach(cur, attnumlist)
  			{
  				int			attnum = lfirst_int(cur);
***************
*** 1779,1789 ****
  				if (csv_mode)
  				{
  					string = CopyReadAttributeCSV(delim, null_print, quote,
! 											   escape, &result, &isnull);
  					if (result == UNTERMINATED_FIELD)
  						ereport(ERROR,
  								(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 							   errmsg("unterminated CSV quoted field")));
  				}
  				else
  					string = CopyReadAttribute(delim, null_print,
--- 2055,2065 ----
  				if (csv_mode)
  				{
  					string = CopyReadAttributeCSV(delim, null_print, quote,
! 												  escape, &result, &isnull);
  					if (result == UNTERMINATED_FIELD)
  						ereport(ERROR,
  								(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 								 errmsg("unterminated CSV quoted field")));
  				}
  				else
  					string = CopyReadAttribute(delim, null_print,
